

val debug : bool ref

val objectOverhead : int
val vtOverhead : int
val arrayLenOffset : int
val arrayDataOffset : int

   (* Command-line options *)
val options: (string * Arg.spec * string) list

   (* The search path for .class files *)
val setClassPath: string -> unit

   (* Find the type of a Java constant *)
val findTypeConstant: string -> (Logic.exp * Proof.proof) option

   (* Check that two constants represent classes that are in the subclass 
    * relationship *)
val checkSubtype: string -> string -> bool

   (* Get the type of an instance field *)
val getFieldType: string -> int -> Logic.exp option

   (* Check the signature of the virtual method *)
val checkSignatureVirtual: host:string -> off:int -> signame:string -> bool
val getSignatureVirtual: host:string -> off:int -> string option
