// astbuild.h
// some utilities for constructing C++ AST nodes

// This is not folded into ast_build.h b/c these things are only
// needed by the verifier; also, e_pre isn't usable outside the
// verifier context, so I'd need a home for it anyway...

#ifndef ASTBUILD_H
#define ASTBUILD_H

#include "cc.ast.gen.h"       // C++ ast decls

// all of these functions accept and return owner pointers

E_unary *e_not(Expression *e);
E_binary *e_equal(Expression *e1, Expression *e2);
E_binary *e_notEqual(Expression *e1, Expression *e2);
E_binary *e_plus(Expression *e1, Expression *e2);
E_binary *e_minus(Expression *e1, Expression *e2);
E_binary *e_and(Expression *e1, Expression *e2);
E_pre *e_pre(E_variable *e);

E_funCall *apply2(E_variable *f, Expression *e1, Expression *e2);
E_funCall *apply3(E_variable *f, Expression *e1, Expression *e2, Expression *e3);
E_funCall *apply4(E_variable *f, Expression *e1, Expression *e2, Expression *e3, Expression *e4);
E_funCall *apply5(E_variable *f, Expression *e1, Expression *e2, Expression *e3, Expression *e4, Expression *e5);

E_variable *makeEVar(SourceLoc loc, StringRef str);

#endif // ASTBUILD_H
