// c2v_ast_aux.cc
// support routines for c2v.ast

#include "c2v.ast.gen.h"     // this module, in a sense
#include "vml.ast.gen.h"     // VML AST
#include "cc.ast.gen.h"      // C++ AST


// there are two unreachable call sites to these 'toString'
// functions in c2v.ast.gen.cc; but there's no harm in leaving
// the definitions

string toString(VStatement const *s)
{
  return s->print();
}

string toString(VExpr const *e)
{
  if (e) {
    return e->print();
  }
  else {
    return "(null VExpr)";
  }
}


void CS_emit::printExtras(ostream &os, int indent) const
{
  PRINT_SUBTREE(stmt);
}

void CS_return::printExtras(ostream &os, int indent) const
{
  PRINT_SUBTREE(expr);
}


void C_Statement::printExtras(ostream &os, int indent) const
{
  PRINT_SUBTREE(cstmt);
}

void C_Expression::printExtras(ostream &os, int indent) const
{
  PRINT_SUBTREE(cexpr);
}

void C_TypeId::printExtras(ostream &os, int indent) const
{
  PRINT_SUBTREE(ctype);
}


// EOF
