// compchain.h
// comparison chain, used for parsing VML

#ifndef COMPCHAIN_H
#define COMPCHAIN_H

#include "vml.ast.gen.h"         // VML AST

// an intermediate structure to aid in parsing
class CompareChain {
public:    // types
  class Elt {
  public:
    SourceLoc loc;
    ComparisonOp op;
    VExpr *exp;                  // (owner)

  public:
    Elt(SourceLoc l, ComparisonOp o, VExpr *e) 
      : loc(l), op(o), exp(e) {}
    ~Elt();
  };

public:
  P_compare *first;              // first expression/op/expression
  ASTList<Elt> links;            // operator,expression pairs after that

public:
  CompareChain(P_compare *first);
  ~CompareChain();

  // consume (delete) 'this', returning an equivalent predicate
  Pred * owner convertToPredicate();
};
  
#endif // COMPCHAIN_H
