// addrglobal.c
// example where the address of a global is used in the
// same way as something that comes from malloc


// --------- verifier preamble ----------
#include "memory.model"

// C functions that are modeled directly
void *malloc(int size);
void free(void *ptr);

// separator between in-memory globals and the heap
int heapStart;


// -------------------- code to verify ------------------
typedef struct Foo {
  int x;
  int y;
} Foo;

Foo global_Foo __varattribute__((addrtaken));


// global invariant
int global_inv() { return vc_expression(all_of {
  0 < heapStart < objct;
  0 < /*&*/global_Foo < heapStart;      // this should be a global assumption, not an invariant..
  tag[/*&*/global_Foo] == Foo_tag;
});}


int addXY(Foo *f)
  pre(0 < f && tag[f]==Foo_tag)
{
  return f->x + f->y;
}


void func()
  changes(objct, objsize, tag, Foo)
{ 
  global_Foo.x = 5;            // write field
  int z = global_Foo.y;        // read field

  addXY(&global_Foo);          // use address

  assert(Foo_x[global_Foo]==5);
  assert(z==Foo_y[global_Foo]);

  struct Foo *f = (struct Foo*)malloc(sizeof(Foo));
  f->x = f->y = 6;
  addXY(f);
  free(f);        

  //ERROR(1): free(&global_Foo);    // this *is* caught by the verifier
}


