// prv_simp.h
// implementation of ProverInterface that works with Simplify

#ifndef PRV_SIMP_H
#define PRV_SIMP_H

#include "prv_int.h"   // ProverInterface
#include "smregexp.h"  // Regexp

class SimplifyInterface : public ProverInterface {
private:     // data                                      
  // regexps for specific situations
  Regexp respValid, respInvalid, respBad, respTriggerless;
  
public:      // funcs
  SimplifyInterface();
  virtual ~SimplifyInterface();

  // implementations of ProverInterface functions
  virtual ReadAction analyzeInitialPrompt(rostring response);
  virtual string getLogfileHeader(rostring fname);
  virtual ReadAction analyzeGoalResponse(rostring response);
  virtual void afterProofCheck(rostring response);
  virtual string extractCounterexample(rostring response);
};

#endif // PRV_SIMP_H
