// rprove.h
// input data structure for the rewriting prover

#ifndef RPROVE_H
#define RPROVE_H

#include "rewrite.h"    // Equality, Axiom
#include "astlist.h"    // ASTList

// toplevel input form
class TopForm {
public:      // types
  // kind of form
  enum Kind {    
    TF_AXIOM,
    TF_EQUALITY,
    TF_DISEQUALITY,
    NUM_KINDS
  };
  
public:      // data
  Kind kind;
  
  // this is a nullable owner ptr
  union {
    Axiom *ax;     // for TF_AXIOM
    Equality *eq;  // for TF_EQUALITY, TF_DISEQUALITY
  };

public:
  TopForm(Kind k, Axiom *a) : kind(k) { ax = a; }
  TopForm(Kind k, Equality *e) : kind(k) { eq = e; }
  ~TopForm();
};


// sequence of forms
class TopFormSeq {
public:
  ASTList<TopForm> forms;
};



#endif // RPROVE_H
