// arrayfield.c
// array as a structure field


// ------------------- preamble ----------------
asm("verifier: include \"ptr.vc\";");
asm("verifier: include \"state.vc\";");

// C functions that are modeled directly
void *malloc(int size);
void memmove(void *dest, void const *src, int len);
void memcpy(void *dest, void const *src, int len);

// declarations of model functions
int sel(int mem, int p);

int tag;
int objct;
int objsize;


// ---------------- code to verify -------------
typedef struct Node {
  int x;
  struct Node *arr[4];
  struct Node *arr2[4];
} Node;
  
Node *p;


#define AND all_of
#define OR one_of
int global_inv() { return vc_expression(AND {
  0 < objct;

  tag[p]==Node_tag;
  tag[p->arr[1]]==Node_tag;
  //p->arr[1]->x == 7;           // problems with how I parse '[]' in VCExprs..
  sel(Node_x, p->arr[1]) == 7;
});}


void f()
  changes(Node_tag)
{
  Node *n;
  assume(tag[n] == Node_tag);

  n->arr[3] = n;
  n->x = 7;
  Node *q = n->arr[3];

  assert(n == q);

  //p->arr[1]->x = 7;
  p->arr[1] = n;
}


void g(Node *n)
  pre(n!=p && 0 < n < objct && tag[n]==Node_tag)
  changes(Node_tag)
{ 
  Node *a0 = n->arr[0];
  Node *a1 = n->arr[1];
  Node *a2 = n->arr[2];
  Node *a3 = n->arr[3];
                                                         
  // overlapping move
  memmove(n->arr+1, n->arr+2, 2 * sizeof(Node*));

  Node *b0 = n->arr[0];
  Node *b1 = n->arr[1];
  Node *b2 = n->arr[2];
  Node *b3 = n->arr[3];

  assert(a0 == b0);
  assert(b1 == a2);
  assert(b2 == a3);
  assert(b3 == a3);

  // non-overlapping copy
  memcpy(n->arr+0, n->arr+2, 2 * sizeof(Node*));

  Node *c0 = n->arr[0];
  Node *c1 = n->arr[1];
  Node *c2 = n->arr[2];
  Node *c3 = n->arr[3];

  assert(c0 == b2);
  assert(c1 == b3);
  assert(c2 == b2);
  assert(c3 == b3);

  // non-overlapping between two arrays
  memcpy(n->arr2+0, n->arr+0, 4 * sizeof(Node*));

  Node *d0 = n->arr2[0];
  Node *d1 = n->arr2[1];
  Node *d2 = n->arr2[2];
  Node *d3 = n->arr2[3];
  
  assert(d0 == c0);
  assert(d1 == c1);
  assert(d2 == c2);
  assert(d3 == c3);
}


