// rule.cc
// code for rule.h

#include "rule.h"         // this module
#include "term.h"         // Term


Rule::Rule(Term *c)
  : premises(),
    conclusion(c)
{}

Rule::~Rule()
{
  delete conclusion;
}


Rule *Rule::clone(int id) const
{
  Rule *ret = new Rule(conclusion->clone(id));

  FOREACH_OBJLIST(Term, premises, iter) {
    ret->premises.prepend(iter.data()->clone(id));
  }
  ret->premises.reverse();
  
  return ret;
}


Rule *makeRule0(Term *c)
{
  return new Rule(c);
}

Rule *makeRule1(Term *c, Term *h)
{
  Rule *ret = new Rule(c);
  ret->premises.prepend(h);
  return ret;
}

Rule *makeRule2(Term *c, Term *h1, Term *h2)
{
  Rule *ret = new Rule(c);
  ret->premises.prepend(h2);
  ret->premises.prepend(h1);
  return ret;
}



// EOF
