# 1 "owner1.c"
// owner1.c
// experiments with owner/serf
              
// OwnerPtrMeta, etc.
# 1 "owner1.h" 1
// owner1.h
// shared declarations for owner-using code; called "owner1.h"
// instead of "owner.h" to avoid conflict with another file I
// use in the implementation..










struct OwnerPtrMeta {      // name is special
  // I think I want to model owner ptrs as tuples generally, so
  // here's the pointer part
  int *ptr;

  // when I see <obj>.<field>, I need to connect <field> with some
  // declared field; so this struct will provide the declaration
  // I need
  int state;
};

//  int offset(int *ptr);
//  int *object(int *ptr);
//  int length(int *obj);
thmprv_predicate int/*bool*/ freshObj(int *obj, int *mem);
thmprv_predicate int okSelOffset(int mem, int offset);
thmprv_predicate int okSel(int mem, int index);
int *sub(int index, int *rest);
int upd(int mem, int index, int value);
int firstIndexOf(int *ptr);





int * owner_ptr_qualifier  allocFunc()
  thmprv_pre(int *pre_mem = mem; true)
  thmprv_post(
    thmprv_exists(
      int address;
      // the returned pointer is a toplevel address only
      address != 0 &&
      result.ptr == sub(address, 0 /*whole*/) &&
      // returns an owner pointer
      result.state == 2  &&
      // to a new object
      !okSel(pre_mem, address) &&
      okSel(mem, address) &&
      // and does not modify anything reachable from pre_mem
      thmprv_exists(int initVal; mem == upd(pre_mem, address, initVal))
    )
  );

void deallocFunc(int * owner_ptr_qualifier  q)
  thmprv_pre(int *pre_mem = mem; 
             //freshObj(object(q), pre_mem) &&
             q.state == 2 )
  thmprv_post(// I treat dealloc as no-op, as if I had a garbage
              // collector; this would actually be *sound*, if I
              // uncommented the 'fresh' precondition (!)
              pre_mem == mem);

// OWNER1_H
# 4 "owner1.c" 2


int main()
{
  int * owner_ptr_qualifier  p;
  //p.state = DEAD;    // now automatic
  thmprv_assert(p.state == 1 );

  p = (int * owner_ptr_qualifier )0;
  //p.ptr = (int *)0;      // now done by assignment as a whole
  //p.state = NULLOWNER;   // now done by assignment as a whole           
  thmprv_assert(p.ptr == (int*)0);
  thmprv_assert(p.state == 0 );
  thmprv_assert(p == (int * owner_ptr_qualifier )0);

  thmprv_assert(p.state != 2 );    // otherwise leak
  p = allocFunc();
  //p.ptr = allocFunc();
  //p.state = OWNING;

  // use
  thmprv_assert(p.state == 2 );
  *p = 6;
  // *(p.ptr) = 6;          // now automatic to use 'ptr'

  thmprv_assert(p.state == 2 );
  int x = *p;
  //int x = *(p.ptr);       // now automatic to use 'ptr'
  thmprv_assert(x == 6);
  thmprv_assert(p.state == 2 );

  
  deallocFunc(p);
  //p.state = DEAD;         // now automatic whenever owner is passed
  thmprv_assert(p.state == 1 );

  // function return
  thmprv_assert(p.state != 2 );    // otherwise leak
  // 1

  return 0;
}




