# 1 "owner2.c"
// owner2.c
// arrays of owners

// OwnerPtrMeta, etc.
# 1 "owner1.h" 1
// owner1.h
// shared declarations for owner-using code; called "owner1.h"
// instead of "owner.h" to avoid conflict with another file I
// use in the implementation..










struct OwnerPtrMeta {      // name is special
  // I think I want to model owner ptrs as tuples generally, so
  // here's the pointer part
  int *ptr;

  // when I see <obj>.<field>, I need to connect <field> with some
  // declared field; so this struct will provide the declaration
  // I need
  int state;
};

//  int offset(int *ptr);
//  int *object(int *ptr);
//  int length(int *obj);
thmprv_predicate int/*bool*/ freshObj(int *obj, int *mem);
thmprv_predicate int okSelOffset(int mem, int offset);
thmprv_predicate int okSel(int mem, int index);
int *sub(int index, int *rest);
int upd(int mem, int index, int value);
int firstIndexOf(int *ptr);





int * owner_ptr_qualifier  allocFunc()
  thmprv_pre(int *pre_mem = mem; true)
  thmprv_post(
    thmprv_exists(
      int address;
      // the returned pointer is a toplevel address only
      address != 0 &&
      result.ptr == sub(address, 0 /*whole*/) &&
      // returns an owner pointer
      result.state == 2  &&
      // to a new object
      !okSel(pre_mem, address) &&
      okSel(mem, address) &&
      // and does not modify anything reachable from pre_mem
      thmprv_exists(int initVal; mem == upd(pre_mem, address, initVal))
    )
  );

void deallocFunc(int * owner_ptr_qualifier  q)
  thmprv_pre(int *pre_mem = mem; 
             //freshObj(object(q), pre_mem) &&
             q.state == 2 )
  thmprv_post(// I treat dealloc as no-op, as if I had a garbage
              // collector; this would actually be *sound*, if I
              // uncommented the 'fresh' precondition (!)
              pre_mem == mem);

// OWNER1_H
# 4 "owner2.c" 2


int main()
{
  int * owner_ptr_qualifier  arr[5];     // array of 5 owner pointers
  int i;
  int *tmp;
  int sum;

  


  


  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  1   ))  );

  for (i=0; i<5; i=i+1) {
    thmprv_invariant(i>=0 && i<5 &&
                     thmprv_forall(int j;   0  <=j && j<    i   ==> (  arr[j].state==  0   ))   &&
                     thmprv_forall(int j;   i  <=j && j<    5   ==> (  arr[j].state==  1   ))  );
    arr[i] = (int * owner_ptr_qualifier )0;
  }

  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  0   ))  );

  


  for (i=0; i<5; i=i+1) {
    thmprv_invariant(i>=0 && i<5 &&
                     thmprv_forall(int j;   0  <=j && j<    i   ==> (  arr[j].state==  2   ))   &&
                     thmprv_forall(int j;  0 <=j && j<  i  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  ))  && 
                     thmprv_forall(int j;   i  <=j && j<    5   ==> (  arr[j].state==  0   ))  );
    arr[i] = allocFunc();
  }

  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  2   ))   &&
                   thmprv_forall(int j;  0 <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  )) );

  for (i=0; i<5; i=i+1) {
    thmprv_invariant(i>=0 && i<5 &&
                     thmprv_forall(int j;  0 <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  ))  &&
                     thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  2   ))  );
    tmp = (int*)(arr[i]);      // cast owner to nonowner
    *tmp = i;
  }

  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  2   ))   &&
                   thmprv_forall(int j;  0 <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  )) );

  sum = 0;
  for (i=0; i<5; i=i+1) {
    thmprv_invariant(i>=0 && i<5 &&
                     thmprv_forall(int j;  0 <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  ))  &&
                     thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  2   ))  );
    tmp = (int*)arr[i];        // cast owner to nonowner
    sum = sum + *tmp;
  }

  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  2   ))   &&
                   thmprv_forall(int j;  0 <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  )) );

  int * owner_ptr_qualifier  tmpOwner;
  for (i=0; i<5; i=i+1) {
    thmprv_invariant(i>=0 && i<5 &&
                     thmprv_forall(int j;   0  <=j && j<    i   ==> (  arr[j].state==  1   ))   &&
                     thmprv_forall(int j;   i  <=j && j<    5   ==> (  arr[j].state==  2   ))   &&
                     thmprv_forall(int j;  i <=j && j<  5  ==> (  (( arr[ j ].ptr  != (int*)0 && okSelOffset(mem,  arr[ j ].ptr ))  && firstIndexOf(arr[ j ].ptr) != firstIndexOf(&arr))  ))  &&
                     tmpOwner.state == 1 );
    tmpOwner = arr[i];
    deallocFunc(tmpOwner);
  }

  thmprv_invariant(thmprv_forall(int j;   0  <=j && j<    5   ==> (  arr[j].state==  1   ))   &&
                   tmpOwner.state == 1 );

  return 0;
}
