// vml_lexer.h            see license.txt for copyright and terms of use
// lexer for VML source files
// adapted from elsa/lexer.h

#ifndef VML_LEXER_H
#define VML_LEXER_H

#include "baselexer.h"      // BaseLexer
#include "vml_tokens.h"     // VMLToken


char const *toString(VMLToken type);


// lexer object
class VMLLexer : public BaseLexer {
protected:  // funcs
  FLEX_OUTPUT_METHOD_DECLS

  // yield a token with StringRef semantic value
  int svalTok(int t);

public:     // funcs
  // make a lexer to scan the given file
  VMLLexer(StringTable &strtable, char const *fname);
  ~VMLLexer();

  // LexerInterface funcs
  virtual string tokenDesc() const;
  virtual string tokenKindDesc(int kind) const;
};


#endif // VML_LEXER_H
