// vml_pred.h
// module for semantically comparing VML predicates, expressions, etc.

#ifndef VML_PRED_H
#define VML_PRED_H

#include "vml.ast.gen.h"     // VML AST

// this is conservative; it may return false even when 'p' and 'q'
// are in fact equivalent
bool equivalent(Pred const *p, Pred const *q);

// true if the sequence of names is the same
bool equalVarLists(ASTList<VD_var> const &list1, ASTList<VD_var> const &list2);
                                                
// true if 'e1' and 'e2' always evaluate to the same thing
bool equalExprs(VExpr const *e1, VExpr const *e2);          

// same sequence of expressions
bool equalExprLists(ASTList<VExpr> const &list1, ASTList<VExpr> const &list2);

// true if 'e' refers to variable 'var'
bool refersTo(VExpr const *e, StringRef var);

// similarly for predicates
bool refersTo(Pred const *p, StringRef var);

#endif // VML_PRED_H
